SndBuf buf;
string fname;
// reporting variables
int lenSamples;
dur duration;
float minAmp;
float maxAmp;
float maxDB;
int minSampIndx;
int maxSampIndx;
float p2pAmp;
float absMaxAmp;
float dcOffset;
float avgRMSAmp;
float avgRMSdb;
float maxRMSAmp;
float maxRMSdb;
int maxRMSstartSamp;
int maxRMSendSamp;
float minRMSAmp;
float minRMSdb;
int minRMSstartSamp;
int minRMSendSamp;
float sampRA[0]; // necessary to initialize one element

// init expects the name of an existing wav file
// init must be called before using any other functions
function void init( string filename )
{
	/*
	set the fname class variable to the filename
	read the filename into the class SndBuf object
	create a lenSamples variable and set it to a bad value -1
	set the lenSamples variable to the number of samples in the SndBuf
	set the duration variable to the duration of the SndBuf
	*/
}

function void info( string header )
{
	/*
	TEST 1 OUTPUT
	==== Test 1 ====  
	Sound file name
	/Users/je/Sites/m208w2014_scrivener/_labs/Lab15/music208minus24dB.wav 
	Length in samples
	108861 
	Duration
	2468.503401 ms
	2.468503 seconds
	0.041142 minutes 
	*/
}

function void fillSampRA( )
{ 
	// The array variable sampRA[] will hold the SndBuf samples.
	// The sample value at index n in SndBuf  is buf.valueAt(n)
	// The total number of samples in SndBuf is lenSamples
	// use a for loop to set every sampRA[n] to the value of buf.valueAt(n)
}

function float db2amp( float dB )
{
	// in Octave code 
	// amp = 10^(dB/20)
	// return amp;
}

function float amp2db( float amp )
{
	// in Octave Code
	// dB = 20 * log10( amp );	
	// return dB;
}

function float getMinAmp()
{
	// find the minimum sample amplitude and the index where it occurs
	// use a for loop to test every sample value
	// if a sample value is less than minA
	// set minA to that value
	// set minSampIndx variable to that index
	// return minA
}

function float getMaxAmp()
{
	// find the maximum sample amplitude and the index where it occurs
	// use a for loop to test every sample value
	// if a sample value is less than maxA
	// set maxA to that value
	// set maxSampIndx variable to that index
	// return that value
}

function float getPeak2PeakAmp()
{
	// add maxAmp and the absolute value of minAmp
	// to get the peak to peak amplitude
	// return result
}

function float getDCOffset()
{
	// cumulatively add up all the sample values in a for loop
	// divide the sum by the total number of samples
	// return the result - that's the DC offxet
}	

function float getAvgRMSAmp()
{
	// use a for loop to add up the sum of all the sample values squared
	// take the square root of the resulting sum, thats rms amplitude
	// convert rms amplitude to dB and set avgRMSdb;
	// return rms
}	

function float getRMSMaxAmp( float millis )
{
	0 => float maxRMS;
	0 => float rms;
	0 => int rmsWinSize;
	0 => int numWins;
	
	// calculate the number of samples in milliseconds
	//    => rmsWinSize;
	// calculate how many "windows" of rmsWinSize can slide
	// across the totnal number of samples in SndBuf
	//    => numWins;
	// OUTER LOOP index w goes from 0 to numWinds
	//    w * rmsWinSize => startN;
	//    0 => rms;
	//    INNER LOOP index n goes from 0 to rmsWinSize
	//    the sample number in the inner loop is
	//        sampRA[ n + startN ]
	//    the inner loop calculates the total sum of the squared amplitudes
	// INSIDE OUTER LOOP
	// check if rms > maxRMS, if it is
	//    rms => maxRMS;
	//    w * rmsWinSize => maxRMSbeginSamp;
	//    maxRMSbeginSamp + rmsWinSize => maxRMSendSamp
	// when both loops finish
	//    square root of (maxRMS / rmsWinSize) => maxRMS
	//    compute amp2db( maxRMS ) and store it in class variable maxRMSdb
	// return maxRMSAmp   
	
}

function float getRMSMinAmp( float millis )
{
	// similar to getRMSMaxAmp( float millis )
}

function void removeDCOffset()
{
	// find the mean by calling getDCOffset()
	// loop through sampRA[] and subract the mean from each sample
	// update the dcOffset class variable
	// getDCOffset() => dcOffset;
}

function void normalize()
{
	// call removeDCOffset();
	// get the maximum amplitude
	// get the minimum amplitude
	// find the absolute value of the minimum amplitude
	// choose the larger of maxA or Math.fabs( minA )
	// determine the amplitude scale factor
	//      1/maxA => scaleBy;
	// loop through sampRA and multiply all values by scaleBy
	//	removeDCOffset();
	//	normalizePositive();
	//	normalizeNegative();
	
}

function void amplify( float dB )
{
	// call removeDCOffset()
	// call normalize()
	// determine new scaleBy
	// db2amp( dB ) => float scaleBy
	// loop through sampRA and multiply all values by scaleBy
}

function int clippedSamples()
{
	// count the number of samples that exceed 1.0 or -1.0
}

function float[] getSamples()
{
	// return sampRA
}

// TESTING
